  /* The API controller
     Exports 3 methods:
     * anotar - Creates a new Todo
     * list - Returns a list of threads
     * show - Displays a thread and its posts
  */
   
   
  var Todo = require('../models/todo.js');
   
  exports.anotar = function(req, res) {
      Todo.create({
          text : req.body.text,
          done : false
      }, function(err, todo) {
          if (err)
              res.send(err);

          // get and return all the todos after you create another
          Todo.find(function(err, todos) {
              if (err)
                  res.send(err)
              res.json(todos);
          });
      });
  }
   
  exports.listar_notas = function(req, res) {
    // use mongoose to get all todos in the database
    Todo.find(function(err, todos) {

        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err)
            res.send(err)

        res.json(todos); // return all todos in JSON format
    });
  }
   
  // first locates a thread by title, then locates the replies by thread ID.
  exports.borrar_nota = function(req, res) {
      Todo.remove({
          _id : req.params.todo_id
      }, function(err, todo) {
          if (err)
              res.send(err);

          // get and return all the todos after you create another
          Todo.find(function(err, todos) {
              if (err)
                  res.send(err)
              res.json(todos);
          });
      });
  }
