  var Calificacion = require('../models/calificacion.js');
  
  exports.createCalificacion = function(req, res) {
      Calificacion.create({
          puntuacion : req.body.puntuacion,
          participante_id: req.body.participante_id,
          tematica_id: req.body.tematica_id
      }, function(err, calificacion) {
          if (err){
            res.send(err);
          }
          // get and return all the calificaciones after you create another
          Calificacion.find(function(err, calificaciones) {
              if (err){
                res.send(err);
              }
              res.json(calificaciones);
          });
      });
  }

  exports.findAll = function(req, res){
    Calificacion.find({})
      .populate('tematica_id')
      .populate('participante_id')
      .exec(function (err, calificaciones) {
        if (err) res.send(err);
         res.json(calificaciones); // return all todos in JSON format
    });
  }

  exports.findByParticipante = function(req, res){
    Calificacion.findByParticipante({ 
      participante_id: req.params.participante_id
    }, function(err, calificaciones) {
      if(err){
        return handleError(err);
      }
      res.json(calificaciones);
    });
  }

  exports.findByTematica = function(req, res){
    Calificacion.findByTematica({ 
      tematica_id: req.params.tematica_id
    }, function(err, calificaciones) {
      if(err){
        return handleError(err);
      }
      res.json(calificaciones);
    });
  }

  exports.updateCalificacion = function(req, res){
    Calificacion.findOne({ 
      participante_id: req.params.participante_id,
      tematica_id: req.params.tematica_id
    }, function(err, calificacion) {
      calificacion.puntuacion = req.body.puntuacion;
      if(err){
        return handleError(err);
      }
      calificacion.save(function(err) {
        if (err){
          return handleError(err);
        }
        res.json({ 
          message: "Puntuacion actualizada."
        });
      });
    });
  }

  exports.getCalificacion = function(req, res){
    Calificacion.findOne({ 
      participante_id: req.params.participante_id,
      tematica_id: req.params.tematica_id 
    }, function(err, calificacion) {
      if (err) 
        return handleError(err);
      res.json(calificacion);
    });
  }
    
  // first locates a thread by title, then locates the replies by thread ID.
  exports.deleteCalificacion = function(req, res) {
      Calificacion.remove({
          participante_id : req.params.participante_id,
          tematica_id: req.params.tematica_id
      }, function(err, calificacion) {
          if (err)
              res.send(err);

          // get and return all the calificaciones after you create another
          Calificacion.find(function(err, calificaciones) {
              if (err)
                  res.send(err)
              res.json(calificaciones);
          });
      });
  }