  var Participante = require('../models/participante.js');
  var Usuario = require('../models/usuario.js');
  var Grupo = require('../models/grupo.js');
  var RespuestaParticipante = require('../models/respuesta_participante.js');
  var waterfall = require('async-waterfall');
  var gcm = require('node-gcm');

  // grupo_id prueba: 559e5d6145f1535c75a915ab
  // usuario_id prueba: 558d287203bd300c021f2b1a
  // perfil_id: QQ
  exports.createParticipante = function(req, res) {
    waterfall([
      function (callback){
        Grupo.findOne({
          _id: req.body.grupo_id
        }, function (err, grupo){
          callback (null, grupo);
        });
      },
      function (grupo, callback){
        Usuario.findOne({
          _id: req.body.usuario_id
        }, function (err, usuario){
          callback (null, grupo, usuario);
        });
      },
      function (grupo, usuario, callback){
        Participante.create({
          ranking: 0,
          participacion: 0.00,
          grupo_id : grupo,
          usuario_id: usuario,
          md_perfil_clave: req.body.perfil_clave
        }, function(err, participante) {
          callback(null, grupo, usuario, participante);
        });
      },
      function (grupo, usuario, participante, callback){
        grupo.numero_participantes += grupo.numero_participantes;
        grupo.save(function (err){
          callback(null, grupo, usuario, participante);
        });
      },
      function (grupo, usuario, participante, callback){
        var sender = new gcm.Sender("AIzaSyABWJ0TfYCNm0YWvKvLcq_vdHIEhWDH-Gs");
        var message = new gcm.Message({
          collapseKey: 'demo',
          priority: 'high',
          contentAvailable: true,
          restrictedPackageName: "org.rul.quickquizz",
          data: {
            topic: 'global',
            mensaje: 'ANYADIDO_A_GRUPO',
            grupo: grupo.nombre,
            cuerpo: 'Se te ha añadido al grupo '
          }
        });
        console.log(message);
        var registrationIds = [];
        registrationIds.push(usuario.tokenGCM);
        sender.send(message, {'registrationIds': registrationIds}, 4, function (err, result) {
          if(err) console.error(err);
          console.log(result);
        });
        callback(null, participante);
      }
      ], function(err, participante){
        res.json(participante);
      }
    );
  }

  exports.findParticipantesByGrupo = function(req, res){
    Participante.find({
      grupo_id: req.params.grupo
    })
    .populate('usuario_id')
    .exec(function (err, participantes) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err){
            res.send(err);
        }
        res.json(participantes); // return all todos in JSON format
    });
  }

  exports.findParticipantesByEmail = function(req, res){
    Usuario.findOne({
      email: req.params.email
    },function(err, usuario){
      // if there is an error retrieving, send the error. nothing after res.send(err) will execute
      if (err){
          res.send(err);
      }
      Participante.find({
        usuario_id : usuario._id
      })
        .populate({      
          path: 'usuario_id',
          match: { email : req.params.email}
        })
        .exec(function(err, participantes) {
          // if there is an error retrieving, send the error. nothing after res.send(err) will execute
          if (err){
              res.send(err);
          }
          res.json(participantes); // return all todos in JSON format
      });
    });
  }

  exports.findAll = function(req, res){
    Participante.find({}).
      populate('usuario_id').
      populate('grupo_id')
      .exec(function(err, participantes) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err){
            res.send(err);
        }
        res.json(participantes); // return all todos in JSON format
    });
  }

  exports.getParticipante = function(req, res){
    Usuario.findById(id, function (err, participante) {
        if(!err){
          res.json(participante);
        } else {
          throw err;
        }
    });
  }

  // first locates a thread by title, then locates the replies by thread ID.
  exports.deleteParticipante = function(req, res) {
      Participante.remove({
          clave : req.params.clave
      }, function(err, participante) {
          if (err)
              res.send(err);

          // get and return all the calificaciones after you create another
          Participante.find(function(err, participantes) {
              if (err)
                  res.send(err)
              res.json(participantes);
          });
      });
  }

  exports.dejarGrupo = function (req, res){
    waterfall([
      function(callback){
        Participante.findOne({
          grupo_id: req.params.grupo_id,
          usuario_id: req.params.usuario_id
        }, function (err, participante){
          callback(null, participante);
        });
      },
      function (participante, callback){
        RespuestaParticipante.remove({
          participante_id: participante._id
        }, function (err, respuestasParticipantes){
          callback(null, participante);
        });
      },
      function (participante, callback){
        Grupo.findOne({
          _id: req.params.grupo_id
        }, function (err, grupo){
          grupo.numero_participantes = grupo.numero_participantes - 1;
          grupo.save(function(err) {
            if (err){
              return handleError(err);
            }
            callback (null, participante);
          });
        });
      },
      function (participante, callback){
        Participante.remove({
          _id: participante._id
        }, function (err, participante){
          callback(null, 1);
        })
      }
      ], function(err, result){
        res.json(result);
      }
    ) 
  }