  var Respuesta = require('../models/respuesta.js');
  var Pregunta = require('../models/pregunta.js');

  exports.createRespuesta = function(req, res) {
      Respuesta.create({
          texto_respuesta: req.body.texto_respuesta,
          aclaracion: req.body.aclaracion,
          texto_libre: req.body.texto_libre,
          valor_correcta: req.body.valor_correcta,
          valor_incorrecta: req.body.valor_incorrecta,
          es_correcta: req.body.es_correcta,
          pregunta_id : req.body.pregunta_id
      }, function (err, respuesta) {
          if (err){
            res.send(err);
          }
          // get and return all the respuestas after you create another
          Pregunta.findOne({            
              _id: req.body.pregunta_id
          },function (err, pregunta) {
              if (err){res.send(err);}
              pregunta.respuesta_id.push(respuesta._id);
              pregunta.save(function(err) {
                if (err){res.send(err);}
                Respuesta.find({
                  pregunta_id: pregunta._id
                }, function (err, respuestas){
                  if (err){res.send(err);}
                  res.json(respuestas);
                });                
              });
          });
      });
  }

  exports.updateRespuesta = function(req, res) {
      Respuesta.findOne({
        _id: req.params.id
      }, function(err, respuesta){
          respuesta.texto_respuesta = req.body.texto_respuesta;
          respuesta.aclaracion = req.body.aclaracion;
          respuesta.texto_libre = req.body.texto_libre;
          respuesta.valor_correcta = req.body.valor_correcta;
          respuesta.valor_incorrecta = req.body.valor_incorrecta;
          respuesta.es_correcta = req.body.es_correcta;
          if (err){res.send(err);}
          respuesta.save(function(err){
            // get and return all the respuestas after you create another
            Respuesta.find({
              pregunta_id: req.body.pregunta_id
            }, function(err, respuestas) {
                if (err){
                  res.send(err);
                }
                res.json(respuestas);
            });
          });
      }); 
  }

  exports.findAll = function(req, res){
    Respuesta.find(function(err, respuestas) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err){
            res.send(err);
        }
        res.json(respuestas); // return all todos in JSON format
    });
  }

  exports.findByPregunta = function(req, res){
    Respuesta.find({pregunta_id: req.params.pregunta},
      function(err, respuestas){
        if(err){
          res.send(err);
        }
        res.json(respuestas);
      });
  }
  
  exports.getRespuesta = function(req, res){
    Respuesta.findOne({
      _id: req.params.id
    }, function(err, respuesta){
      if(err){
        res.send(err);
      }
      res.json(respuesta);
    });
  }

  // first locates a thread by title, then locates the replies by thread ID.
  exports.deleteRespuesta = function(req, res) {
      Respuesta.remove({
          _id : req.params.id
      }, function(err, respuesta) {
        if (err){res.send(err);}
        Pregunta.findOne({            
            _id: req.params.preguntaid
        },function (err, pregunta) {
          if (err){res.send(err);}
          var respuestasIdsActualizado = [];
          var respuestasIds = pregunta.respuesta_id;
          for (var i in respuestasIds) {
            if(req.params.id != respuestasIds[i]){
              respuestasIdsActualizado.push(respuestasIds[i]);
            }              
          }
          pregunta.respuesta_id = respuestasIdsActualizado;
          pregunta.save(function(err) {
            if (err){res.send(err);}
            Respuesta.find({
              pregunta_id: req.params.preguntaid
            }, function (err, respuestas){
              if (err){res.send(err);}
              res.json(respuestas);
            });                
          });            
        });
      });
  }