var Tematica = require('../models/tematica.js');
  var Grupo = require('../models/grupo.js');
  var Participante = require('../models/participante.js');
  var Pregunta = require('../models/pregunta.js');
  var waterfall = require('async-waterfall');

  exports.createTematica = function(req, res) {
    Grupo.findOne({
      _id: req.body.grupo_id
    }, function (err, grupo){
      if (err){
        res.send(err);
      }
      Tematica.create({
        nombre : req.body.nombre,
        grupo_id : grupo
      }, function(err, tematica) {
        if (err){
          res.send(err);
        }
        // get and return all the tematicas after you create another
        Grupo.findOne({ 
          _id: tematica.grupo_id 
        }, function (err, grupo) {
          grupo.numero_tematicas = grupo.numero_tematicas + 1;
          if(err){
            return handleError(err);
          }
          grupo.save(function(err) {
            if (err){
              return handleError(err);
            }
            Tematica.find(function(err, tematicas) {
              if (err){
                res.send(err);
              }
              res.json(tematicas);
            });
          });
        });
      });
    });    
  }
/*
  exports.findAll = function(req, res){
    Tematica.find(function(err, tematicas) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err){
            res.send(err);
        }
        res.json(tematicas); // return all todos in JSON format
    });
  }
*/
  exports.findAll = function(req, res){
    Tematica.find({})
      .populate('grupo_id')
      .exec(function (err, tematicas) {
        if (err) res.send(err);
         res.json(tematicas); // return all todos in JSON format
    });
  }

  exports.findByGrupo = function(req, res){
    Tematica.find({
      grupo_id: req.params.grupoId
    })
      .exec(function (err, tematicas) {
        if (err) res.send(err);
         res.json(tematicas); // return all todos in JSON format
    });
  }

  exports.findByQuizzer = function(req, res){
    waterfall([
      function (callback){
        Participante.find({
          usuario_id: req.params.usuarioId,
          md_perfil_clave: {$ne: 'ZP'}
        },function (err, participantes) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
          if (err){res.send(err);}
          var gruposId = [];
          for (var i in participantes) {
            gruposId.push(participantes[i].grupo_id);
          }
          callback(null, gruposId);
        });
      },
      function (gruposId, callback){
        Tematica.find({
          grupo_id: {$in: gruposId}
        },function (err, tematicas) {
          if(err){
            return handleError(err);
          }
          callback(null, tematicas);
        });
      },
      function (tematicas, callback){
        var agg = [
          {$group: {
            _id: "$tematica_id",
            total: {$sum: 1}
          }}
        ];
        Pregunta.aggregate(agg, function(err, numeroPreguntas){
          if (err) { return res.send(err); }
          for(var i in tematicas){
            var tematica = tematicas[i];
            for(var j in numeroPreguntas){
              var tematicaIdTe = tematicas[i]._id;
              var tematicaIdPr = numeroPreguntas[j]._id;
              if(tematicaIdTe.equals(tematicaIdPr)){
                tematicas[i].numero_preguntas = numeroPreguntas[j].total;
                break;
              }else{
                tematicas[i].numero_preguntas = 0;
              }
            }
          }
          callback(null, tematicas);
        });
      }
      ], function(err, result){
        res.json(result);
      }
    )  
  }
exports.updateTematica = function(req, res){
    Tematica.findOne({ 
      _id: req.params.id
    }, function(err, tematica) {
      if(err){
        return handleError(err);
      }
      tematica.nombre = req.body.nombre;
      Grupo.findOne({
        _id: req.body.grupo_id
      }, function (err, grupo){
        if(err){
          return handleError(err);
        }
        tematica.grupo_id = grupo;
        tematica.save(function(err) {
          if (err){
            return handleError(err);
          }
          res.json({ 
            message: "Grupo actualizado."
          });
        });
      });
    });
  }
  // first locates a thread by title, then locates the replies by thread ID.
  exports.deleteTematica = function(req, res) {
      Tematica.remove({
          _id : req.params.id
      }, function(err, tematica) {
          if (err)
              res.send(err);

          // get and return all the calificaciones after you create another
          Tematica.find(function(err, tematicas) {
              if (err)
                  res.send(err)
              res.json(tematicas);
          });
      });
  }