  var Usuario = require('../models/usuario.js');
  var gcm = require('node-gcm');
  var waterfall = require('async-waterfall');
    
  exports.createUsuario = function(req, res) {
      Usuario.find({
        $or: [
          {'local.email': req.body.email},
          {'local.nombre': req.body.nombre}
        ]
      }, function(err, usuarioLocal){
        if(err){
          return res.send(err);
        }
        if(usuarioLocal.local != undefined){
          return res.json({ 
                message: "Usuario ya existente."
              });
        }else{
          Usuario.find({
            'google.email': req.params.email
          }, function(err, usuarioGoogle){
            if(err){
              return res.send(err);
            }
            if(usuarioGoogle.google != undefined){
              usuarioGoogle.local.nombre = req.body.nombre;
              usuarioGoogle.local.email = req.body.email;
              usuarioGoogle.local.password = usuarioGoogle.generateHash(req.body.password);
              usuarioGoogle.save(function(err) {
                if (err){
                  return handleError(err);
                }
                res.json({ 
                  message: "Usuario actualizado."
                });
              });
            }else{
              var newUser            = new Usuario();
              newUser.local.nombre   = req.body.nombre;
              newUser.local.email    = req.body.email;
              newUser.local.password = newUser.generateHash(req.body.password);
              newUser.save(function(err) {
                  if (err)
                      throw err;

                  return res.json(newUser);
              });
            }
          });
        }
      });      
  }

  exports.createUsuarioGoogle = function(req, res) {
    console.log(req.body);
    Usuario.findOne({
     $or: [
        {'local.email': req.body.email},
        {'local.nombre': req.body.nombreGoogle}
      ]
    }, function(err, usuarioLocal){ 
      console.log("UsuarioLocal ==> " + usuarioLocal);
      if(err){
        return res.send(err);
      }
      if(usuarioLocal != undefined){
        if(usuarioLocal.google == undefined){
          usuarioLocal.google = {};
        }
        usuarioLocal.google.id = req.body.idGoogle;
        usuarioLocal.google.name = req.body.nombreGoogle;
        usuarioLocal.google.avatar = req.body.avatar;
        usuarioLocal.google.email = req.body.email;
        usuarioLocal.google.token = req.body.tokenGoogle;
        usuarioLocal.save(function(err) {
          if (err){
            return handleError(err);
          }
          res.json({ 
            message: "Usuario actualizado."
          });
        });
      }else{
        Usuario.findOne({
          'google.email': req.body.email
        }, function(err, usuarioGoogle){
          console.log("UsuarioGoogle ==> " + usuarioGoogle);
          if(err){
            return res.send(err);
          }
          if(usuarioGoogle != undefined){
            usuarioLocal.google.id = req.body.idGoogle;
            usuarioLocal.google.name = req.body.nombreGoogle;
            usuarioLocal.google.avatar = req.body.avatar;
            usuarioLocal.google.email = req.body.email;
            usuarioLocal.google.token = req.body.tokenGoogle;
            usuarioGoogle.save(function(err) {
              if (err){
                return handleError(err);
              }
              res.json({ 
                message: "Usuario actualizado."
              });
            });
          }else{
            var newUser            = new Usuario();
            newUser.local = {};
            newUser.local.nombre   = req.body.nombre;
            newUser.local.email    = req.body.email;
            newUser.google = {};
            newUser.google.id = req.body.idGoogle;
            newUser.google.name = req.body.nombreGoogle;
            newUser.google.avatar = req.body.avatar;
            newUser.google.email = req.body.email;
            newUser.google.token = req.body.tokenGoogle;
            newUser.save(function(err) {
                if (err)
                    throw err;
            console.log(newUser);
                return res.json(newUser);
            });
          }
        });
      }
    });      
  }

  exports.googleSignUp = function(req, res){
    console.log(req.body);
    Usuario.findOne({ 
      'google.email': req.body.email
    }, function(err, usuarioGoogle) {
      // if there are any errors, return the error
        if (err){
            return res.send(err);
        }
        // if no usuario is found, return the message
        if (!usuarioGoogle){
          Usuario.findOne({ 
            'local.email': req.body.email
          }, function(err, usuarioLocal) {
            if(err){
              return res.send(err);
            }
            if(!usuarioLocal){
              usuario.local.email = req.body.email;
              usuario.local.nombre =  req.body.name;
            }
            usuarioLocal.google.id = req.body.id;
            usuarioLocal.google.avatar = req.body.avatar;
            usuarioLocal.google.name = req.body.name;
            usuarioLocal.google.token = req.body.token;
            usuarioLocal.google.email = req.body.email;
            usuarioLocal.save(function(err) {
              if (err){
                return handleError(err);
              }
              res.json({ 
                message: "Usuario actualizado."
              });
            });
          });
        }else{
          if(usuarioGoogle.google.token == undefined || usuarioGoogle == null){
            usuarioGoogle.google.id = req.body.id;
            usuarioGoogle.google.avatar = req.body.avatar;
            usuarioGoogle.google.name = req.body.name;
            usuarioGoogle.google.token = req.body.token;
            usuarioGoogle.google.email = req.body.email;
            usuarioGoogle.save(function(err) {
              if (err){
                return handleError(err);
              }
              res.json({ 
                message: "Token actualizado."
              });
            });
          }else{
            return res.json(usuarioGoogle);
          }
        }
    });
  }

  exports.findAll = function(req, res){
    Usuario.find(function(err, usuarios) {
        // if there is an error retrieving, send the error. nothing after res.send(err) will execute
        if (err){
            res.send(err);
        }
        res.json(usuarios); // return all todos in JSON format
    });
  }
  exports.localLogin = function(req, res){
    Usuario.findOne({ 
      'local.email' :  req.body.email 
    }, function(err, usuario) {
      // if there are any errors, return the error
        if (err)
            return res.send(err);

        // if no usuario is found, return the message
        if (!usuario || !usuario.validPassword(req.body.password))
            return  res.json({ 
                      message: "Usuario o password incorrecto."
                    });

        // all is well, return usuario
        else
            return res.json(usuario);
    });
  }

  exports.findGoogleByEmail = function(req, res){
    Usuario.findOne({ 
        'google.email': req.params.email
    }, function (err, usuario) {
      if (err) 
        return handleError(err);
      res.json(usuario);
    });
  }

  exports.findByEmail = function(req, res){
    Usuario.findOne({ 
      $or: [
        {'local.email': req.params.email},
        {'google.email': req.params.email}
      ]      
    }, function (err, usuario) {
      if (err) 
        return handleError(err);
      res.json(usuario);
    });
  }

  exports.updateUsuario = function(req, res){
    Usuario.findOne({ 
      email: req.params.email 
    }, function (err, usuario) {
      usuario.nombre = req.body.nombre;
      if(err){
        return handleError(err);
      }
      usuario.save(function(err) {
        if (err){
          return handleError(err);
        }
        res.json({ 
          message: "Usuario actualizado."
        });
      });
    });
  }

  exports.getUsuario = function(req, res){
    console.log(req.params);
    Usuario.findOne({ 
      _id: req.params.id 
    }, function (err, usuario) {
      if (err) 
        return handleError(err);
      res.json(usuario);
    });
  }
    
  // first locates a thread by title, then locates the replies by thread ID.
  exports.deleteUsuario = function(req, res) {
      Usuario.remove({
          $or: [
            {'local.email': req.params.email},
            {'google.email': req.params.email}
          ] 
      }, function(err, usuario) {
          if (err)
              res.send(err);

          // get and return all the usuarios after you create another
          Usuario.find(function(err, usuarios) {
              if (err)
                  res.send(err)
              res.json(usuarios);
          });
      });
  }

  exports.registrarGCM = function (req, res){
    Usuario.findOne({
      _id: req.params.id
    }, function (err, usuario){
      console.log("Usuario: " +  usuario._id);
      console.log("tokenGCM: " + req.body.tokenGCM);
      usuario.tokenGCM = req.body.tokenGCM;
      usuario.save( function (err, usuario){
        console.log(usuario);
        res.json({ "registro" : "true"});
      });
    });
  }

  exports.desregistrarGCM = function (req, res){
    Usuario.findOne({
      _id: req.params.id
    }, function (err, usuario){
      console.log(usuario);
      if(usuario != null){
        console.log("Usuario: " +  usuario._id);
        usuario.tokenGCM = '';
        usuario.save( function (err, usuario){
          console.log(usuario);
          res.json({ "desregistro" : "true"});
        }); 
      }           
    });
  }

  exports.sendGCM = function (req, res){
    waterfall([
      function (callback){
        var registrationIds = [];
        Usuario.find({
          tokenGCM: {$ne: ''}
        }, function (err, usuarios){
          for(var i in usuarios){
            registrationIds.push(usuarios[i].tokenGCM);
          }
          console.log(registrationIds);
          callback(null, registrationIds);
        });
      },      
      ], function(err, registrationIds){
        var sender = new gcm.Sender("AIzaSyABWJ0TfYCNm0YWvKvLcq_vdHIEhWDH-Gs");
        var message = new gcm.Message({
          collapseKey: 'demo',
          priority: 'high',
          contentAvailable: true,
          restrictedPackageName: "org.rul.quickquizz",
          data: {
            topic: 'global',
            mensaje: 'MENSAJE_GLOBAL',
            cuerpo: req.body.mensaje
          }
        });
        
        //registrationIds.push('f-wZrhhVyiM:APA91bEUOg_LdE1IBXBrj3KHgrPHMO_mtJNiS8s9b9Lu9kzWj_kVhGMDeMluT57YS3Tee41K3EHgB0I29CLeMR3OEAVKpSkEp8S8rCnAPEoFJj7YDecd8FsI9rXlTsaC8LjjN5OS11xA');
       sender.send(message, {'registrationIds': registrationIds}, 4, function (err, result) {
          if(err) console.error(err);
          console.log(result);
        });
/*        sender.send(message,  {'topic': ['/topics/global']}, function (err, result) {
            if(err) console.error(err);
            console.log(result);
        });*/
        res.redirect('/sendGCM');
      });    
  }

/*
  var gcm = require('node-gcm');
   
  // Create a message 
  // ... with default values 
  var message = new gcm.Message();
   
  // ... or some given values 
  var message = new gcm.Message({
      collapseKey: 'demo',
      priority: 'high',
      contentAvailable: true,
      delayWhileIdle: true,
      timeToLive: 3,
      restrictedPackageName: "org.rul.quickquizz",
      dryRun: true,
      data: {
          key1: 'message1',
          key2: 'message2'
      },
      notification: {
          title: "Hello, World",
          icon: "ic_launcher",
          body: "This is a notification that will be displayed ASAP."
      }
  });
   
  // Change the message data 
  // ... as key-value 
  message.addData('key1','message1');
  message.addData('key2','message2');
   
  // ... or as a data object (overwrites previous data object) 
  message.addData({
      key1: 'message1',
      key2: 'message2'
  });
   
  // Set up the sender with you API key 
  var sender = new gcm.Sender('AIzaSyABWJ0TfYCNm0YWvKvLcq_vdHIEhWDH-Gs');
   
  // Add the registration IDs of the devices you want to send to 
  var registrationIds = [];
  registrationIds.push('e0AbngkA864:APA91bFzYoJJ5eEo9YQI-60FJcjKc-psUUiZUcjh9LyWd0_DEpstlMM5jljhoGWOYxEbTK9I1AXikPwoNlJJk04319bwUKKx5F1HtoLdadSRafI7jAJFT9sWv3U1lIX2GkGqSt0I-NnK');
  //registrationIds.push('regId2');
   
  // Send the message 
  // ... trying only once 
  sender.sendNoRetry(message, { registrationIds: registrationIds }, function(err, result) {
    console.log("sendNoRetry");
    if(err) console.error(err);
    else    console.log(result);
  });
   
  // ... or retrying 
  sender.send(message, { registrationIds: registrationIds }, function (err, result) {
    console.log("send");
    if(err) console.error(err);
    else    console.log(result);
  });
   
  // ... or retrying a specific number of times (10) 
  sender.send(message, { registrationIds: registrationIds }, 10, function (err, result) {
    console.log("send 10");
    if(err) console.error(err);
    else    console.log(result);
  });

  */