// The Pregunta model
 
var mongoose = require('mongoose'),
	Schema = mongoose.Schema,
	ObjectId = Schema.ObjectId;
 
var preguntaSchema = new Schema({
    titulo: String,
    enunciado: String,
    tipo: String,
    numero_respuestas: Number,
    fecha_alta: String,
    fecha_baja: String,
    hora_alta: Number,
    hora_baja: Number,
    fecha_publicacion: String,
    hora_publicacion: Number,
    fecha_limite: String,
    hora_limite: Number,
    nombre_grupo: String,
    grupo_id: String,
    nombre_quizzer: String,
    avatar_quizzer: String,
    numero_participantes: Number,
    numero_contestaciones: Number,
    totales_respuestas: Number,
    tematica_id: { type: Schema.Types.ObjectId, ref: 'Tematica' },
    quizzer_id: { type: Schema.Types.ObjectId, ref: 'Participante' },
    respuesta_id: [{type: Schema.Types.ObjectId, ref: 'Respuesta'}]
});
 
module.exports = mongoose.model('Pregunta', preguntaSchema);