// The Usuario model
 
var bcrypt   = require('bcrypt-nodejs');
var mongoose = require('mongoose'),
	Schema = mongoose.Schema,
	ObjectId = Schema.ObjectId;
 
var usuarioSchema = new Schema({
    local            : {
        email        : String,
        nombre		 : String,
        password     : String,
    },
    google           : {
        id           : String,
        token        : String,
        email        : String,
        name         : String,
        avatar       : String
    },
    tokenGCM: String
});

// generating a hash
usuarioSchema.methods.generateHash = function(password) {
    return bcrypt.hashSync(password, bcrypt.genSaltSync(8), null);
};

// checking if password is valid
usuarioSchema.methods.validPassword = function(password) {
    return bcrypt.compareSync(password, this.local.password);
};

module.exports = mongoose.model('Usuario', usuarioSchema);