var preguntaService = angular.module('preguntaService', []);

preguntaService.service('preguntaSrv', ['$http', function($http) {  
    var urlBase = '/api/pregunta/';
    var urlBaseLista = '/api/preguntas/'
    var preguntaFactory = {};

    var preguntasTest = [{
        _id: "1",
        titulo: "Introducción a OpenCV",
        enunciado: "Suponga que crea una nueva Mat con la orden Mat img = new Mat(300,200, CvType.CV_16SC2). Indica cuántos bytes ocuparan lo pixeles de dicha imagen. ",
        tipo: "MONORESPUESTA",
        numero_respuestas: 4,
        fecha_alta: "20150714",
        hora_alta: 1,
        fecha_publicacion: "20150714",
        hora_publicacion: 1,
        fecha_limite: "20150729",
        hora_limite: 1,
        tematica_id: "10",
        quizzer_id: "558d3b8f4b069a03003ca287",
        email: "raul.gomo@gmail.com",
        grupo_id: "10"
    },
    {
        _id: "2",
        titulo: "Introducción a OpenCV",
        enunciado: "Para reservar memoria para una imagen de 400 pixeles de ancho y 300 pixeles de alto en formato RGBA debería emplear.",
        tipo: "MONORESPUESTA",
        numero_respuestas: 6,
        fecha_alta: "20150714",
        hora_alta: 1,
        fecha_publicacion: "20150714",
        hora_publicacion: 1,
        fecha_limite: "20150729",
        hora_limite: 1,
        tematica_id: "10",
        quizzer_id: "558d3b8f4b069a03003ca287",
        email: "raul.gomo@gmail.com",
        grupo_id: "10"  
    },
    {
        _id: "3",
        titulo: "Introducción a OpenCV",
        enunciado: "Supongamos que tenemos una imagen img1 que tiene 300 pixeles de ancho y 200 pixeles de alto y escribimos la siguiente instrucción Mat img2 = img1.colRange(210,220). Indica cuál de las siguientes frases es cierta.",
        tipo: "MONORESPUESTA",
        numero_respuestas: 6,
        fecha_alta: "20150714",
        hora_alta: 1,
        fecha_publicacion: "20150714",
        hora_publicacion: 1,
        fecha_limite: "20150729",
        hora_limite: 1,
        tematica_id: "10",
        quizzer_id: "558d3b8f4b069a03003ca287",
        email: "raul.gomo@gmail.com",
        grupo_id: "10"  
    }];

    this.getPreguntas = function(){
        //return preguntasTest;
        return $http.get(urlBaseLista + 'sinrespuestas');
    };
    this.getPreguntasMisGrupos = function(usuarioid){
        //return preguntasTest;
        return $http.get(urlBaseLista + 'tematicas/' + usuarioid);
    };
    this.getMisPreguntas = function(usuarioid){
        console.log(usuarioid);
        return $http.get(urlBaseLista + "usuario/" + usuarioid);
    };
    this.getPregunta = function(id){
        //return preguntasTest[id];
        return $http.get(urlBase + id);
    };
    this.deletePregunta = function(pregunta) {
        return $http.delete(urlBase + pregunta._id + "/" + pregunta.quizzer_id._id);
    };

    this.createPregunta = function(pregunta) {
        return $http.post(urlBase, pregunta);
    };
    this.updatePregunta= function(pregunta) {
        return $http.put(urlBase + pregunta._id, pregunta);
    };

}]);