'use strict';
require("./participante.test");
require("./tematica.test");

// import the moongoose helper utilities
var utils = require('./utils.js');
var should = require('should');
// import our Usuario mongoose model
var Participante = require('../models/participante.js');
var Tematica = require('../models/tematica.js');
var Calificacion = require('../models/calificacion.js');

describe('Calificacion: models', function () {

  it('Probamos a crear una calificacion para un raul.gomo@gmail.com y una Fragments', function (done) {
  	Tematica.findOne({nombre:"Fragments"}, function(err, tematica){
  		if(err) return done(err);
  		should.not.exist(err);

  		Participante.findOne({
  			grupo_id: tematica.grupo_id,
		  	}).populate({
		  		path: 'usuario_id',
				'local.email': "raul.gomo@gmail.com"
		  	}).exec(function (err, participante) {
		      	if (err) res.send(err);
		        Calificacion.create({
		        	puntuacion: 9.5,
	    			participante_id : participante._id,
	    			tematica_id:  tematica._id
		        }, function (err, CreateCalificacion){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
			    });
	    	});
  		});
  	});
  it('Probamos a crear una calificacion para un raul.gomo@gmail.com y una Ciclo de vida', function (done) {
  	Tematica.findOne({nombre:"Ciclo de vida"}, function(err, tematica){
  		if(err) return done(err);
  		should.not.exist(err);

  		Participante.findOne({
  			grupo_id: tematica.grupo_id,
		  	}).populate({
		  		path: 'usuario_id',
				'local.email': "raul.gomo@gmail.com"
		  	}).exec(function (err, participante) {
		      	if (err) res.send(err);
		        Calificacion.create({
		        	puntuacion: 6,
	    			participante_id : participante._id,
	    			tematica_id:  tematica._id
		        }, function (err, CreateCalificacion){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
			    });
	    	});
  		});
  	});
});