'use strict';
require("./usuario.test");
require("./grupo.test");
require("./perfil.test");
// import the moongoose helper utilities
var utils = require('./utils.js');
var should = require('should');
// import our Usuario mongoose model
var Participante = require('../models/participante.js');
var Usuario = require('../models/usuario.js');
var Grupo = require('../models/grupo.js');
var MD_Perfil = require('../models/md_perfil.js');

describe('Participante: models', function () {

  it('Probamos a asignar participantes Quizzer para el grupo público', function (done) {
    Grupo.findOne({nombre: "Android Básico"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);      
      grupo.nombre.should.equal('Android Básico');
      Usuario.findOne({
        $or: [
          {'local.email': 'raul.gomo@gmail.com'},
          {'google.email': 'raul.gomo@gmail.com'}
        ]  
      }, function(errU, usuario){
        if (errU) return done(errU);
        should.not.exist(errU);
        //usuario.email.should.equal('raul.gomo@gmail.com');
        MD_Perfil.findOne({_id: "QZ"}, function(err, perfil){
          if (err) return done(err);
          should.not.exist(err);
          perfil._id.should.equal('QZ');
          Participante.create({
            ranking: 0,
            participacion: 0,
            grupo_id : grupo._id,
            usuario_id : usuario._id,
            md_perfil_clave : perfil._id
          },function(err, createParticipante){
            if (err) return done(err);
            should.not.exist(err);
            Grupo.findOne({ 
              _id: createParticipante.grupo_id 
            }, function (err, grupo) {
              grupo.numero_participantes = grupo.numero_participantes + 1;
              if(err){
                return handleError(err);
              }
              grupo.save(function(err) {
                if (err){
                  return handleError(err);
                }
                console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_participantes + " número temáticas.");
              });
            });
            Participante
              .findOne({ _id: createParticipante._id })
              .populate('usuario_id')
              .exec(function (err, participante) {
                if (err) return handleError(err);
                console.log('El participante se llama ', participante.usuario_id.nombre);
                done();
            });
          });
        });
      });
    });
  });
  it('Probamos a asignar participantes Zappy para el grupo publico', function (done) {
    Grupo.findOne({nombre: "Android Básico"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Básico');

      Usuario.findOne({
          $or: [
            {'local.email': 'fer@gmail.com'},
            {'google.email': 'fer@gmail.com'}
          ]  
        }, function(errU, usuario){
        if (errU) return done(errU);
        should.not.exist(errU);
        
        //usuario.emil.should.equal('fer@gmail.com');

        MD_Perfil.findOne({_id: "ZP"}, function(err, perfil){
          if (err) return done(err);
          should.not.exist(err);
          
          perfil._id.should.equal('ZP');

          Participante.create({
            ranking: 0,
            participacion: 0,
            grupo_id : grupo._id,
            usuario_id : usuario._id,
            md_perfil_clave : perfil._id
          },function(err, createParticipante){
            if (err) return done(err);
            should.not.exist(err);
            Grupo.findOne({ 
              _id: createParticipante.grupo_id 
            }, function (err, grupo) {
              grupo.numero_participantes = grupo.numero_participantes + 1;
              if(err){
                return handleError(err);
              }
              grupo.save(function(err) {
                if (err){
                  return handleError(err);
                }
                console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_participantes + " número temáticas.");
              });
            });
            Participante
              .findOne({ _id: createParticipante._id })
              .populate('usuario_id')
              .exec(function (err, participante) {
                if (err) return handleError(err);
                console.log('El participante se llama ', participante.usuario_id.nombre);
                done();
            });
          });
        });
      });
    });
  });
it('Probamos a asignar un participante Quizzer para el grupo privado', function (done) {
    Grupo.findOne({nombre: "Android Avanzado"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Avanzado');

      Usuario.findOne({
        $or: [
          {'local.email': 'riky@gmail.com'},
          {'google.email': 'riky@gmail.com'}
        ]  
      }, function(errU, usuario){
        if (errU) return done(errU);
        should.not.exist(errU);
        
        //usuario.email.should.equal('riky@gmail.com');

        MD_Perfil.findOne({_id: "QZ"}, function(err, perfil){
          if (err) return done(err);
          should.not.exist(err);
          
          perfil._id.should.equal('QZ');

          Participante.create({
            ranking: 0,
            participacion: 0,
            grupo_id : grupo._id,
            usuario_id : usuario._id,
            md_perfil_clave : perfil._id
          },function(err, createParticipante){
            if (err) return done(err);
            should.not.exist(err);
            Grupo.findOne({ 
              _id: createParticipante.grupo_id 
            }, function (err, grupo) {
              grupo.numero_participantes = grupo.numero_participantes + 1;
              if(err){
                return handleError(err);
              }
              grupo.save(function(err) {
                if (err){
                  return handleError(err);
                }
                console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_participantes + " número temáticas.");
              });
            });
            Participante
              .findOne({ _id: createParticipante._id })
              .populate('usuario_id')
              .exec(function (err, participante) {
                if (err) return handleError(err);
                console.log('El participante se llama ', participante.usuario_id.nombre);
                done();
            });
          });
        });
      });
    });
  });
  it('Probamos a asignar un participante Zappy para el grupo privado', function (done) {
    Grupo.findOne({nombre: "Android Avanzado"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Avanzado');

      Usuario.findOne({
        $or: [
          {'local.email': 'raul.gomo@gmail.com'},
          {'google.email': 'raul.gomo@gmail.com'}
        ]  
      }, function(errU, usuario){
        if (errU) return done(errU);
        should.not.exist(errU);
        
        //usuario.email.should.equal('raul.gomo@gmail.com');

        MD_Perfil.findOne({_id: "ZP"}, function(err, perfil){
          if (err) return done(err);
          should.not.exist(err);
          
          perfil._id.should.equal('ZP');

          Participante.create({
            ranking: 0,
            participacion: 0,
            grupo_id : grupo._id,
            usuario_id : usuario._id,
            md_perfil_clave : perfil._id
          },function(err, createParticipante){
            if (err) return done(err);
            should.not.exist(err);
            Grupo.findOne({ 
              _id: createParticipante.grupo_id 
            }, function (err, grupo) {
              grupo.numero_participantes = grupo.numero_participantes + 1;
              if(err){
                return handleError(err);
              }
              grupo.save(function(err) {
                if (err){
                  return handleError(err);
                }
                console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_participantes + " número temáticas.");
              });
            });
            Participante
              .findOne({ _id: createParticipante._id })
              .populate('usuario_id')
              .exec(function (err, participante) {
                if (err) return handleError(err);
                console.log('El participante se llama ', participante.usuario_id.nombre);
                done();
            });
          });
        });
      });
    });
  });
});