'use strict';
require("./participante.test");
require("./tematica.test");
require("./usuario.test");

// import the moongoose helper utilities
var utils = require('./utils.js');
var should = require('should');
// import our Usuario mongoose model
var Participante = require('../models/participante.js');
var Tematica = require('../models/tematica.js');
var Pregunta = require('../models/pregunta.js');
var Respuesta = require('../models/respuesta.js');
var Usuario = require('../models/usuario.js');

describe('Pregunta: models', function () {

  	it('Probamos a crear una Pregunta con el quizzer raul.gomo@gmail.com y la tematica Fragments', function (done) {
  		Tematica.findOne({nombre:"Bluetooth"}, function(err, tematica){
	  		if(err) return done(err);
	  		should.not.exist(err);
			Participante.find({
				grupo_id: tematica.grupo_id,
	          	md_perfil_clave: 'QZ'
			})
	        .populate({      
	          path: 'usuario_id',
	          match: { 
	          	$or: [
		          {'local.email': 'riky@gmail.com'},
		          {'google.email': 'riky@gmail.com'}
		        ]  
	          }
	        })
	        .exec(function(err, participante) {
	          	if(err) return done(err);
  				should.not.exist(err);
		        Pregunta.create({
		        	titulo: 'PR1',
				    enunciado: '¿Qué relación hay entre fragments y actividades? ',
				    tipo: 'MONORESPUESTA',
				    numero_respuestas: 4,
				    fecha_alta: 20150716,
				    hora_alta: 36000,
				    fecha_publicacion: 20150716,
				    hora_publicacion: 36000,
				    fecha_limite: 20150726,
				    hora_limite: 82800,
	    			quizzer_id : participante[0]._id,
	    			tematica_id:  tematica._id
		        }, function (err, createPregunta){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();		        	
			    });
	      	});
  		});  		
  	});
  it('Probamos a crear una Pregunta con el quizzer raul.gomo@gmail.com y la tematica Fragments', function (done) {
  		Tematica.findOne({nombre:"Bluetooth"}, function(err, tematica){
	  		if(err) return done(err);
	  		should.not.exist(err);
			Participante.find({
				grupo_id: tematica.grupo_id,
	          	md_perfil_clave: 'QZ'
			})
	        .populate({      
	          path: 'usuario_id',
	          match: { 
	          	$or: [
		          {'local.email': 'riky@gmail.com'},
		          {'google.email': 'riky@gmail.com'}
		        ]  
	          }
	        })
	        .exec(function(err, participante) {
	          	if(err) return done(err);
  				should.not.exist(err);
		        Pregunta.create({
		        	titulo: 'PR2',
				    enunciado: 'Si usamos fragments en el diseño de nuestras aplicaciones... ',
				    tipo: 'MONORESPUESTA',
				    numero_respuestas: 4,
				    fecha_alta: 20150716,
				    hora_alta: 36000,
				    fecha_publicacion: 20150716,
				    hora_publicacion: 36000,
				    fecha_limite: 20150726,
				    hora_limite: 82800,
	    			quizzer_id : participante[0]._id,
	    			tematica_id:  tematica._id
		        }, function (err, createPregunta){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
			    });
	  		});
	  	});
	});
  	it('Probamos a crear una Pregunta con el quizzer raul.gomo@gmail.com y la tematica Ciclo de vida', function (done) {
  		Tematica.findOne({nombre:"Surface views"}, function(err, tematica){
	  		if(err) return done(err);
	  		should.not.exist(err);
			Participante.find({
				grupo_id: tematica.grupo_id,
	          	md_perfil_clave: 'QZ'
			})
	        .populate({      
	          path: 'usuario_id',
	          match: { 
	          	$or: [
		          {'local.email': 'riky@gmail.com'},
		          {'google.email': 'riky@gmail.com'}
		        ]  
	          }
	        })
	        .exec(function(err, participante) {
	          	if(err) return done(err);
  				should.not.exist(err);
		        Pregunta.create({
		        	titulo: 'PR3',
				    enunciado: '¿Cuándo hay que utilizar los métodos del ciclo de vida? ',
				    tipo: 'MONORESPUESTA',
				    numero_respuestas: 4,
				    fecha_alta: 20150716,
				    hora_alta: 36000,
				    fecha_publicacion: 20150716,
				    hora_publicacion: 36100,
				    fecha_limite: 20150726,
				    hora_limite: 82800,
	    			quizzer_id : participante[0]._id,
	    			tematica_id:  tematica._id
			    }, function (err, createPregunta){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
				});
		   	});
	  	});
  	});
  	it('Probamos a crear una Pregunta con el quizzer raul.gomo@gmail.com y la tematica Ciclo de vida', function (done) {
  		Tematica.findOne({nombre:"Ciclo de vida"}, function(err, tematica){
	  		if(err) return done(err);
	  		should.not.exist(err);
			Participante.find({
				grupo_id: tematica.grupo_id,
	          	md_perfil_clave: 'QZ'
			})
	        .populate({      
	          path: 'usuario_id',
	          match: { 
	          	$or: [
		          {'local.email': 'raul.gomo@gmail.com'},
		          {'google.email': 'raul.gomo@gmail.com'}
		        ]  
	          }
	        })
	        .exec(function(err, participante) {
	          	if(err) return done(err);
  				should.not.exist(err);
		        Pregunta.create({
		        	titulo: 'PR4',
				    enunciado: 'Has arrancado una animación en el método onResume() ¿En qué método tendrías que detenerla? ',
				    tipo: 'MONORESPUESTA',
				    numero_respuestas: 4,
				    fecha_alta: 20150716,
				    hora_alta: 36000,
				    fecha_publicacion: 20150716,
				    hora_publicacion: 36000,
				    fecha_limite: 20150726,
				    hora_limite: 82800,
	    			quizzer_id : participante[0]._id,
	    			tematica_id:  tematica._id
		        }, function (err, createPregunta){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
			    });
		    });
		});
	});
	it('Probamos a crear una Pregunta con el quizzer raul.gomo@gmail.com y la tematica Ciclo de vida', function (done) {
  		Tematica.findOne({nombre:"Ciclo de vida"}, function(err, tematica){
	  		if(err) return done(err);
	  		should.not.exist(err);
			Participante.find({
				grupo_id: tematica.grupo_id,
	          	md_perfil_clave: 'QZ'
			})
	        .populate({      
	          path: 'usuario_id',
	          match: { 
	          	$or: [
		          {'local.email': 'raul.gomo@gmail.com'},
		          {'google.email': 'raul.gomo@gmail.com'}
		        ]  
	          }
	        })
	        .exec(function(err, participante) {
	          	if(err) return done(err);
  				should.not.exist(err);
		        Pregunta.create({
		        	titulo: 'PR5',
				    enunciado: '¿Cual de los siguientes métodos pertenecen al ciclo de vida de una Activity? ',
				    tipo: 'MULTIRESPUESTA',
				    numero_respuestas: 5,
				    fecha_alta: 20150716,
				    hora_alta: 36000,
				    fecha_publicacion: 20150716,
				    hora_publicacion: 36000,
				    fecha_limite: 20150726,
				    hora_limite: 82800,
	    			quizzer_id : participante[0]._id,
	    			tematica_id:  tematica._id
		        }, function (err, createPregunta){
			        if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
			        done();
			    });
		    });
	  	});
  	});
})