'use strict';
require("./pregunta.test");

// import the moongoose helper utilities
var utils = require('./utils.js');
var should = require('should');
// import our Usuario mongoose model
var Pregunta = require('../models/pregunta.js');
var Respuesta = require('../models/respuesta.js');

describe('Respuesta: models', function () {
  	it('Probamos a crear las respuestas de la pregunta PR1', function (done) {
  		Pregunta.findOne({
  			titulo: 'PR1'
  		}, function (err, pregunta){
	  		Respuesta.create({
				texto_respuesta: 'La clase Fragment es descendiente de Activity.',
			    aclaracion: '',
			    texto_libre: '',
			    es_correcta: 'S',
			    valor_correcta: 1,
			    valor_incorrecta: 0,
			    pregunta_id : pregunta._id
	    	}, function (err, createRespuesta){
	    		if (err) return done(err);
		        // Confirm that that an error does not exist
		        should.not.exist(err);
				pregunta.respuesta_id.push(createRespuesta);

				Respuesta.create({
	        		texto_respuesta: 'Los fragments reemplazan a las actividades en el diseño de IU',
				    aclaracion: '',
				    texto_libre: '',
			    	es_correcta: 'N',
				    valor_correcta: 0,
				    valor_incorrecta: 0,
				    pregunta_id : pregunta._id
	        	}, function (err, createRespuesta){
	        		if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
					pregunta.respuesta_id.push(createRespuesta);

			        Respuesta.create({
		        		texto_respuesta: 'Los fragments los utilizaremos en tabletas y las actividades en móviles',
					    aclaracion: 'aclaracion 2',
					    texto_libre: '',
			    		es_correcta: 'N',
					    valor_correcta: 0,
					    valor_incorrecta: 0,
					    pregunta_id : pregunta._id
		        	}, function (err, createRespuesta){
		        		if (err) return done(err);
				        // Confirm that that an error does not exist
				        should.not.exist(err);
						pregunta.respuesta_id.push(createRespuesta);

				        Respuesta.create({
			        		texto_respuesta: ' Una actividad puede contener varios fragments',
						    aclaracion: '',
						    texto_libre: '',
			    			es_correcta: 'N',
						    valor_correcta: 0,
						    valor_incorrecta: 0,
						    pregunta_id : pregunta._id
			        	}, function (err, createRespuesta){
			        		if (err) return done(err);
					        // Confirm that that an error does not exist
					        should.not.exist(err);
					        console.log(pregunta._id);
					        pregunta.respuesta_id.push(createRespuesta);
					        pregunta.save();
		        			done();
		        		});
		        	});
		        });
			});
    	});
  	});
  	it('Probamos a crear las respuestas de la pregunta PR2', function (done) {
  		Pregunta.findOne({
  			titulo: 'PR2'
  		}, function (err, pregunta){
	  		Respuesta.create({
				texto_respuesta: 'Tendremos que trabajar con una versión máxima del SDK 3.0',
			    aclaracion: '',
			    texto_libre: '',
			    valor_correcta: 1,
			    valor_incorrecta: 0,
			    pregunta_id : pregunta._id
	    	}, function (err, createRespuesta){
	    		if (err) return done(err);
		        // Confirm that that an error does not exist
		        should.not.exist(err);
				pregunta.respuesta_id.push(createRespuesta);

				Respuesta.create({
	        		texto_respuesta: 'Tendremos que incluir una librería de compatibilidad para que la aplicación funcione sobre dispositivos antiguos',
				    aclaracion: '',
				    texto_libre: '',
				    valor_correcta: 1,
				    valor_incorrecta: 0,
				    pregunta_id : pregunta._id
	        	}, function (err, createRespuesta){
	        		if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
					pregunta.respuesta_id.push(createRespuesta);

			        Respuesta.create({
		        		texto_respuesta: 'El del interfaz de usuario se adaptará automáticamente al tamaño del dispositivo',
					    aclaracion: '',
					    texto_libre: '',
					    valor_correcta: 1,
					    valor_incorrecta: 0,
					    pregunta_id : pregunta._id
		        	}, function (err, createRespuesta){
		        		if (err) return done(err);
				        // Confirm that that an error does not exist
				        should.not.exist(err);
						pregunta.respuesta_id.push(createRespuesta);

				        Respuesta.create({
			        		texto_respuesta: 'Todas las respuestas son correctas',
						    aclaracion: '',
						    texto_libre: '',
						    valor_correcta: 1,
						    valor_incorrecta: 0,
						    pregunta_id : pregunta._id
			        	}, function (err, createRespuesta){
			        		if (err) return done(err);
					        // Confirm that that an error does not exist
					        should.not.exist(err);
					        console.log(pregunta._id);
					        pregunta.respuesta_id.push(createRespuesta);
					        pregunta.save();
		        			done();
		        		});
		        	});
		        });
			});
    	});
  	});
  	it('Probamos a crear las respuestas de la pregunta PR3', function (done) {
  		Pregunta.findOne({
  			titulo: 'PR3'
  		}, function (err, pregunta){
	  		Respuesta.create({
				texto_respuesta: 'Siempre que necesitemos utilizar el API multimedia',
			    aclaracion: '',
			    texto_libre: '',
			    valor_correcta: 1,
			    valor_incorrecta: 0,
			    pregunta_id : pregunta._id
	    	}, function (err, createRespuesta){
	    		if (err) return done(err);
		        // Confirm that that an error does not exist
		        should.not.exist(err);
				pregunta.respuesta_id.push(createRespuesta);

				Respuesta.create({
	        		texto_respuesta: 'Para arrancar y detener servicios',
				    aclaracion: '',
				    texto_libre: '',
				    valor_correcta: 1,
				    valor_incorrecta: 0,
				    pregunta_id : pregunta._id
	        	}, function (err, createRespuesta){
	        		if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
					pregunta.respuesta_id.push(createRespuesta);

			        Respuesta.create({
		        		texto_respuesta: 'Cuando queramos que nuestra actividad se comporte de forma diferente cuando esté en estado: activa, visible, parada o destruida.',
					    aclaracion: '',
					    texto_libre: '',
					    valor_correcta: 1,
					    valor_incorrecta: 0,
					    pregunta_id : pregunta._id
		        	}, function (err, createRespuesta){
		        		if (err) return done(err);
				        // Confirm that that an error does not exist
				        should.not.exist(err);
						pregunta.respuesta_id.push(createRespuesta);

				        Respuesta.create({
			        		texto_respuesta: 'Todas las respuestas son correctas',
						    aclaracion: '',
						    texto_libre: '',
						    valor_correcta: 1,
						    valor_incorrecta: 0,
						    pregunta_id : pregunta._id
			        	}, function (err, createRespuesta){
			        		if (err) return done(err);
					        // Confirm that that an error does not exist
					        should.not.exist(err);
					        console.log(pregunta._id);
					        pregunta.respuesta_id.push(createRespuesta);
					        pregunta.save();
		        			done();
		        		});
		        	});
		        });
			});
    	});
  	});
  	it('Probamos a crear las respuestas de la pregunta PR4', function (done) {
  		Pregunta.findOne({
  			titulo: 'PR4'
  		}, function (err, pregunta){
	  		Respuesta.create({
				texto_respuesta: 'onPause()',
			    aclaracion: '',
			    texto_libre: '',
			    valor_correcta: 1,
			    valor_incorrecta: 0,
			    pregunta_id : pregunta._id
	    	}, function (err, createRespuesta){
	    		if (err) return done(err);
		        // Confirm that that an error does not exist
		        should.not.exist(err);
				pregunta.respuesta_id.push(createRespuesta);

				Respuesta.create({
	        		texto_respuesta: 'onStop()',
				    aclaracion: '',
				    texto_libre: '',
				    valor_correcta: 1,
				    valor_incorrecta: 0,
				    pregunta_id : pregunta._id
	        	}, function (err, createRespuesta){
	        		if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
					pregunta.respuesta_id.push(createRespuesta);

			        Respuesta.create({
		        		texto_respuesta: 'onDestroy()',
					    aclaracion: '',
					    texto_libre: '',
					    valor_correcta: 1,
					    valor_incorrecta: 0,
					    pregunta_id : pregunta._id
		        	}, function (err, createRespuesta){
		        		if (err) return done(err);
				        // Confirm that that an error does not exist
				        should.not.exist(err);
						pregunta.respuesta_id.push(createRespuesta);

				        Respuesta.create({
			        		texto_respuesta: 'Cualquier método sería valido',
						    aclaracion: '',
						    texto_libre: '',
						    valor_correcta: 1,
						    valor_incorrecta: 0,
						    pregunta_id : pregunta._id
			        	}, function (err, createRespuesta){
			        		if (err) return done(err);
					        // Confirm that that an error does not exist
					        should.not.exist(err);
					        console.log(pregunta._id);
					        pregunta.respuesta_id.push(createRespuesta);
					        pregunta.save();
		        			done();
		        		});
		        	});
		        });
			});
    	});
  	});
  	it('Probamos a crear las respuestas de la pregunta PR5', function (done) {
  		Pregunta.findOne({
  			titulo: 'PR5'
  		}, function (err, pregunta){
	  		Respuesta.create({
				texto_respuesta: 'onPause()',
			    aclaracion: '',
			    texto_libre: '',
			    valor_correcta: 1,
			    valor_incorrecta: 0,
			    pregunta_id : pregunta._id
	    	}, function (err, createRespuesta){
	    		if (err) return done(err);
		        // Confirm that that an error does not exist
		        should.not.exist(err);
				pregunta.respuesta_id.push(createRespuesta);

				Respuesta.create({
	        		texto_respuesta: 'onCreateView()',
				    aclaracion: '',
				    texto_libre: '',
				    valor_correcta: 1,
				    valor_incorrecta: 0,
				    pregunta_id : pregunta._id
	        	}, function (err, createRespuesta){
	        		if (err) return done(err);
			        // Confirm that that an error does not exist
			        should.not.exist(err);
					pregunta.respuesta_id.push(createRespuesta);

			        Respuesta.create({
		        		texto_respuesta: 'onStop()',
					    aclaracion: '',
					    texto_libre: '',
					    valor_correcta: 1,
					    valor_incorrecta: 0,
					    pregunta_id : pregunta._id
		        	}, function (err, createRespuesta){
		        		if (err) return done(err);
				        // Confirm that that an error does not exist
				        should.not.exist(err);
						pregunta.respuesta_id.push(createRespuesta);

				        Respuesta.create({
			        		texto_respuesta: 'onDestroy()',
						    aclaracion: '',
						    texto_libre: '',
						    valor_correcta: 1,
						    valor_incorrecta: 0,
						    pregunta_id : pregunta._id
			        	}, function (err, createRespuesta){
			        		if (err) return done(err);
					        // Confirm that that an error does not exist
					        should.not.exist(err);
					        pregunta.respuesta_id.push(createRespuesta);
					        Respuesta.create({
				        		texto_respuesta: 'onAttach()',
							    aclaracion: '',
							    texto_libre: '',
							    valor_correcta: 1,
							    valor_incorrecta: 0,
							    pregunta_id : pregunta._id
				        	}, function (err, createRespuesta){
				        		if (err) return done(err);
						        // Confirm that that an error does not exist
						        should.not.exist(err);
						        console.log(pregunta._id);
						        pregunta.respuesta_id.push(createRespuesta);
					        	pregunta.save();
		        				done();
		        			});
		        		});
		        	});
		        });
			});
    	});
  	});  		
});