'use strict';
require("./grupo.test");

// import the moongoose helper utilities
var utils = require('./utils.js');
var should = require('should');
// import our Usuario mongoose model
var Grupo = require('../models/grupo.js');
var Tematica = require('../models/tematica.js');

describe('Tematica: models', function () {
/*
  beforeEach(function(done){    
    Usuario.remove({}, function() { 
      console.log('Limpiamos usuario');    
      done();    
    });  
  });  
*/
  it('Probamos a crear dos tematicas para el grupo publico', function (done) {
    Grupo.findOne({nombre: "Android Básico"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Básico');
      Tematica.create({
        nombre: "Ciclo de vida",
        grupo_id: grupo._id
      }, function(err, model){
        if (err) return done(err);
        
        // Confirm that that an error does not exist
        should.not.exist(err);
        Tematica.create({
          nombre: "Fragments",
          grupo_id: grupo._id
        }, function(err, model){
          if (err) return done(err);
          Grupo.findOne({ 
            _id: model.grupo_id 
          }, function (err, grupo) {
            grupo.numero_tematicas = grupo.numero_tematicas + 1;
            if(err){
              return handleError(err);
            }
            grupo.save(function(err) {
              if (err){
                return handleError(err);
              }
              console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_tematicas + " número temáticas.");
            });
          });
          Tematica.find({grupo_id: grupo._id}, function(err, docs){
            if (err) return done(err);

            // without clearing the DB between specs, this would be 3
            docs.length.should.equal(2);
            done();
          });
        });
      });
    });
  });
  it('Probamos a crear dos tematicas para el grupo privado', function (done) {
    Grupo.findOne({nombre: "Android Avanzado"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Avanzado');
      Tematica.create({
        nombre: "Bluetooth",
        grupo_id: grupo._id
      }, function(err, model){
        if (err) return done(err);
        
        // Confirm that that an error does not exist
        should.not.exist(err);
        Tematica.create({
          nombre: "Surface views",
          grupo_id: grupo._id
        }, function(err, model){
          if (err) return done(err);
          Grupo.findOne({ 
            _id: model.grupo_id 
          }, function (err, grupo) {
            grupo.numero_tematicas = grupo.numero_tematicas + 1;
            if(err){
              return handleError(err);
            }
            grupo.save(function(err) {
              if (err){
                return handleError(err);
              }
              console.log("Grupo " + grupo._id + " actualizado a " + grupo.numero_tematicas + " número temáticas.");
            });
          });
          Tematica.find({grupo_id: grupo._id}, function(err, docs){
            if (err) return done(err);

            // without clearing the DB between specs, this would be 3
            docs.length.should.equal(2);
            done();
          });
        });
      });
    });
  });

  it('Probamos que el indice funciona introduciendo grupo y tematica repetida', function (done) {
    Grupo.findOne({nombre: "Android Básico"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Básico');
      Tematica.create({
        nombre: "Ciclo de vida",
        grupo_id: grupo._id
      }, function(err, model){        
        // Confirm that that an error does not exist
        should.exist(err);
        done();
      });
    });
  });

  it('Probamos que el indice funciona introduciendo grupo distinto y tematica repetida', function (done) {
    Grupo.findOne({nombre: "Android Avanzado"}, function(err, grupo){
      if (err) return done(err);
      should.not.exist(err);
      
      grupo.nombre.should.equal('Android Avanzado');
      Tematica.create({
        nombre: "Fragments",
        grupo_id: grupo._id
      }, function(err, model){
        // Confirm that that an error does not exist
        should.exist(err);
        done();
      });
    });
  });
});