'use strict';

/*
* Modified from https://github.com/elliotf/mocha-mongoose
*/

var config = require('../config');
var mongoose = require('mongoose');
// import our Usuario mongoose model
var Usuario = require('../models/usuario.js');
var MD_Perfil = require('../models/md_perfil.js');
var Grupo = require('../models/grupo.js');
var Participante = require('../models/participante.js');
var Tematica = require('../models/tematica.js');
var Calificacion = require('../models/calificacion.js');
var Pregunta = require('../models/pregunta.js');
var Respuesta = require('../models/respuesta.js');

// ensure the NODE_ENV is set to 'test'
// this is helpful when you would like to change behavior when testing
process.env.NODE_ENV = 'test';

beforeEach(function (done) {

  function clearDB() {
    /*Usuario.remove({}, function() { 
      console.log('Limpiamos usuario');       
    }); */
    MD_Perfil.remove({}, function() { 
      console.log('Limpiamos perfiles');    
    });
    Grupo.remove({}, function() { 
      console.log('Limpiamos grupo');    
    });
    Participante.remove({}, function() { 
      console.log('Limpiamos participantes');    
    });
    Tematica.remove({}, function() { 
      console.log('Limpiamos tematicas');    
    });
    Calificacion.remove({}, function() { 
      console.log('Limpiamos calificaciones');    
    });
    Pregunta.remove({}, function() { 
      console.log('Limpiamos preguntas');    
    });
    Respuesta.remove({}, function() { 
      console.log('Limpiamos respuestas');    
    });
    done();   
  }

  if (mongoose.connection.db) return done();

  mongoose.connect(config.db.test, function (err) {
    if (err) {
      throw err;
    }
    //console.log('Connectamos con: ' + config.db.test);
    //console.log('Llamamos a limpiar');
    return clearDB();
  });

});

afterEach(function (done) {
  //mongoose.disconnect();
  //console.log('Desconectamos'); 
  return done();
});