Date.prototype.yyyymmdd = function() {
   var yyyy = this.getFullYear().toString();
   var mm = (this.getMonth()+1).toString(); // getMonth() is zero-based
   var dd  = this.getDate().toString();
   return yyyy + (mm[1]?mm:"0"+mm[0]) + (dd[1]?dd:"0"+dd[0]); // padding
};

var parserStrToDate = function(str) {
    if(!/^(\d){8}$/.test(str)) return "invalid date";
    var y = str.substr(0,4),
        m = str.substr(4,2),
        d = str.substr(6,2);
    return new Date(y,m-1,d);
}

var parserDateToStr = function(str){
    if(str == ""){
      return str;
    }
    if(!/^(\d){2}\/(\d){2}\/(\d){4}$/.test(str)) return null;
    var yyyy = str.substr(6,4),
        mm = str.substr(3,2),
        dd = str.substr(0,2);
    return yyyy + (mm[1]?mm:"0"+mm[0]) + (dd[1]?dd:"0"+dd[0]); // padding
};

module.exports = {
  parserStrToDate: parserStrToDate,
  parserDateToStr: parserDateToStr
}